#include <QDebug>
#include "trafficmap.h"

trafficmap::trafficmap() : QList()
{
}

void trafficmap::addToScene(QGraphicsScene * scene) {
    for (auto r : *this) {
        scene->addLine (QLineF(r.p1, r.p2));
    }
}

// Parse a road section.
void readRoad(QString str, trafficmap &map) {
    QStringList words = str.split(' ', QString::SkipEmptyParts);

    QString name = words[0];

    if (name == "road") {
        road r;
        double x1 = words[1].toDouble();
        double y1 = words[2].toDouble();
        double x2 = words[3].toDouble();
        double y2 = words[4].toDouble();

        r.p1 = QPoint (x1,y1);
        r.p2 = QPoint (x2,y2);
        map.push_back(r);
    }
}


// Traffic maps just need the road sections for the visualization.
// One could also take the car positions but this (should) be
// available in the log file.
trafficmap map_from_file(QFile& file) {
    trafficmap map;
    if (!file.open(QIODevice::ReadOnly | QIODevice::Text))
        qDebug() << "file failed to open";

    while (!file.atEnd()) {
        QString contents = file.readLine();
        readRoad (contents, map);
    }
    return map;
}
